package com.businessrefinery.barcode.linear.demo;


import com.businessrefinery.barcode.linear.encoder.GifEncoder;
import com.businessrefinery.barcode.linear.Linear;
import com.sun.image.codec.jpeg.*;
import java.awt.*;
import java.awt.image.BufferedImage;
import java.io.IOException;
import javax.servlet.ServletException;
import javax.servlet.http.*;


public class DemoServlet extends HttpServlet
{

    private boolean debug;

    public DemoServlet()
    {
        debug = true;
    }

    public void init()
        throws ServletException
    {
    }

    private Linear getChart(HttpServletRequest request)
    {
        Linear linear = new Linear();
        if(request != null)
        {
            if(request.getParameter("CODE") != null)
            {
                linear.setDataToEncode(request.getParameter("CODE"));
            }
            if(request.getParameter("BARCODE_TYPE") != null)
            {
                String s = request.getParameter("CODE_TYPE");
                if(s.compareTo("CODE39") == 0)
                {
                    linear.barcodeType = 0;
                }
                if(s.compareTo("CODE39EXT") == 0)
                {
                    linear.barcodeType = 1;
                }
                if(s.compareTo("INTERLEAVED25") == 0)
                {
                    linear.barcodeType = 2;
                }
                if(s.compareTo("CODE11") == 0)
                {
                    linear.barcodeType = 3;
                }
                if(s.compareTo("CODABAR") == 0)
                {
                    linear.barcodeType = 4;
                }
                if(s.compareTo("MSI") == 0)
                {
                    linear.barcodeType = 5;
                }
                if(s.compareTo("UPCA") == 0)
                {
                    linear.barcodeType = 6;
                }
                if(s.compareTo("IND25") == 0)
                {
                    linear.barcodeType = 7;
                }
                if(s.compareTo("MAT25") == 0)
                {
                    linear.barcodeType = 8;
                }
                if(s.compareTo("CODE93") == 0)
                {
                    linear.barcodeType = 9;
                }
                if(s.compareTo("EAN13") == 0)
                {
                    linear.barcodeType = 10;
                }
                if(s.compareTo("EAN8") == 0)
                {
                    linear.barcodeType = 11;
                }
                if(s.compareTo("UPCE") == 0)
                {
                    linear.barcodeType = 12;
                }
                if(s.compareTo("CODE128") == 0)
                {
                    linear.barcodeType = 13;
                }
                if(s.compareTo("CODE93EXT") == 0)
                {
                    linear.barcodeType = 14;
                }
                if(s.compareTo("POSTNET") == 0)
                {
                    linear.barcodeType = 15;
                }
                if(s.compareTo("PLANET") == 0)
                {
                    linear.barcodeType = 16;
                }
                if(s.compareTo("UCC128") == 0)
                {
                    linear.barcodeType = 17;
                }
                if(s.compareTo("ONECODE") == 0)
                {
                    linear.barcodeType = 18;
                }
            }
            if(request.getParameter("ADD_CHECK_DIGIT") != null)
            {
                linear.checkCharacter = request.getParameter("ADD_CHECK_DIGIT").compareTo("Y") == 0;
            }
            if(request.getParameter("ADD_CHECK_DIGIT_TO_TEXT") != null)
            {
                linear.checkCharacterInText = request.getParameter("ADD_CHECK_DIGIT_TO_TEXT").compareTo("Y") == 0;
            }
            if(request.getParameter("CODE128_CHAR_SET") != null)
            {
                linear.Code128Set = (request.getParameter("CODE128_CHAR_SET") + "B").charAt(0);
            }
            if(request.getParameter("EAN_UPC_SUPPLEMENT") != null)
            {
                linear.UPCEANSupplement2 = false;
                linear.UPCEANSupplement5 = false;
                if(request.getParameter("EAN_UPC_SUPPLEMENT").compareTo("2") == 0)
                {
                    linear.UPCEANSupplement2 = true;
                }
                if(request.getParameter("EAN_UPC_SUPPLEMENT").compareTo("5") == 0)
                {
                    linear.UPCEANSupplement5 = true;
                }
            }
            if(request.getParameter("UPCE_SYSTEM") != null)
            {
                linear.UPCESystem = (new String(request.getParameter("UPCE_SYSTEM") + "1")).charAt(0);
            }
            if(request.getParameter("ROTATE_ANGLE") != null)
            {
                linear.setRotationAngle((int)(new Double(request.getParameter("ROTATE_ANGLE"))).doubleValue());
            }
            if(request.getParameter("X") != null)
            {
                linear.X = (new Double(request.getParameter("X"))).doubleValue();
            }
            if(request.getParameter("N") != null)
            {
                linear.N = (new Double(request.getParameter("N"))).doubleValue();
            }
            if(request.getParameter("WHITE_BAR_INCREASE") != null)
            {
                linear.whiteBarIncrease = (new Float(request.getParameter("WHITE_BAR_INCREASE"))).floatValue();
            }
            if(request.getParameter("BAR_HEIGHT") != null)
            {
                linear.barHeightCM = (new Double(request.getParameter("BAR_HEIGHT"))).doubleValue();
            }
            if(request.getParameter("BACKGROUND_COLOR") != null)
            {
                linear.backgroundColor = convertColor(request.getParameter("BACKGROUND_COLOR"));
            }
            if(request.getParameter("BAR_COLOR") != null)
            {
                linear.barColor = convertColor(request.getParameter("BAR_COLOR"));
            }
            if(request.getParameter("TEXT_COLOR") != null)
            {
                linear.textFontColor = convertColor(request.getParameter("TEXT_COLOR"));
            }
            if(request.getParameter("TEXT_FONT") != null)
            {
                linear.textFont = convertFont(request.getParameter("TEXT_FONT"));
            }
            if(request.getParameter("TEXT_MARGIN") != null)
            {
                linear.textMarginCM = (new Double(request.getParameter("TEXT_MARGIN"))).doubleValue();
            }
            if(request.getParameter("BEARERBAR_HORIZONTAL") != null)
            {
                linear.bearerBarHori = (new Double(request.getParameter("BEARERBAR_HORIZONTAL"))).doubleValue();
            }
            if(request.getParameter("BEARERBAR_VERTICAL") != null)
            {
                linear.bearerBarVert = (new Double(request.getParameter("BEARERBAR_VERTICAL"))).doubleValue();
            }
            if(request.getParameter("CHARACTER_GROUPING") != null)
            {
                linear.valSpliceText = (new Integer(request.getParameter("CHARACTER_GROUPING"))).intValue();
            }

        }
        else
        {
            linear.code = "No Data";
        }
        return linear;
    }

    public Font convertFont(String s)
    {
        String as[];
        byte byte0;
        as = convertList(s);
        if(as == null)
        {
            return null;
        }
        if(as.length < 3)
        {
            return null;
        }
        byte0 = 0;
        if(as[1].compareTo("BOLD") == 0)
        {
            byte0 = 1;
        }
        if(as[1].compareTo("ITALIC") == 0)
        {
            byte0 = 2;
        }

        try {
            return new Font(as[0], byte0, (new Integer(as[2])).intValue());
        } catch (Exception e) {
            return null;
        }

    }

    private String[] convertList(String s)
    {
        String as[] = new String[500];
        int i = 0;
        for(int j = s.indexOf("|"); j >= 0; j = s.indexOf("|"))
        {
            as[i++] = s.substring(0, j);
            s = s.substring(j + 1, s.length());
        }

        if(s.compareTo("") != 0)
        {
            as[i++] = s;
        }
        if(i == 0)
        {
            return null;
        }
        String as1[] = new String[i];
        for(int k = 0; k < i; k++)
        {
            as1[k] = as[k];
        }

        return as1;
    }

    public Color convertColor(String s)
    {
        if(s.compareTo("NULL") == 0)
        {
            return null;
        }
        if(s.compareTo("RED") == 0)
        {
            return Color.red;
        }
        if(s.compareTo("BLACK") == 0)
        {
            return Color.black;
        }
        if(s.compareTo("BLUE") == 0)
        {
            return Color.blue;
        }
        if(s.compareTo("CYAN") == 0)
        {
            return Color.cyan;
        }
        if(s.compareTo("DARKGRAY") == 0)
        {
            return Color.darkGray;
        }
        if(s.compareTo("GRAY") == 0)
        {
            return Color.gray;
        }
        if(s.compareTo("GREEN") == 0)
        {
            return Color.green;
        }
        if(s.compareTo("LIGHTGRAY") == 0)
        {
            return Color.lightGray;
        }
        if(s.compareTo("MAGENTA") == 0)
        {
            return Color.magenta;
        }
        if(s.compareTo("ORANGE") == 0)
        {
            return Color.orange;
        }
        if(s.compareTo("PINK") == 0)
        {
            return Color.pink;
        }
        if(s.compareTo("WHITE") == 0)
        {
            return Color.white;
        }
        if(s.compareTo("YELLOW") == 0)
        {
            return Color.yellow;
        }

        try {
            return Color.decode(s);
        } catch (Exception e) {
            return Color.black;
        }

    }

    public void doGet(HttpServletRequest httpservletrequest, HttpServletResponse httpservletresponse)
        throws ServletException, IOException
    {
        String s = "jpeg";
        if(httpservletrequest != null)
        {
            if(httpservletrequest.getParameter("FORMAT") != null)
            {
                s = httpservletrequest.getParameter("FORMAT").toLowerCase();
            }
            if(s.compareTo("gif") != 0)
            {
                s = "jpeg";
            }
        }
        httpservletresponse.setContentType("image/" + s);
        javax.servlet.ServletOutputStream servletoutputstream = httpservletresponse.getOutputStream();
        httpservletresponse.setHeader("Pragma", "no-cache");
        httpservletresponse.setHeader("Cache-Control", "no-cache");
        httpservletresponse.setDateHeader("Expires", 0L);
        try
        {
            int i = 10;
            int j = 10;
            Linear barcode = getChart(httpservletrequest);
            if(httpservletrequest != null && httpservletrequest.getParameter("WIDTH") != null && httpservletrequest.getParameter("HEIGHT") != null)
            {
                i = (new Integer(httpservletrequest.getParameter("WIDTH"))).intValue();
                j = (new Integer(httpservletrequest.getParameter("HEIGHT"))).intValue();
            } else
            {
                barcode.autoSize = true;
                barcode.setSize(600, 90);
                BufferedImage bufferedimage = new BufferedImage(barcode.getSize().width, barcode.getSize().height, 13);
                java.awt.Graphics2D graphics2d = bufferedimage.createGraphics();
                barcode.paint(graphics2d);
                barcode.invalidate();
                i = barcode.getSize().width;
                j = barcode.getSize().height;
                graphics2d.dispose();
            }
            BufferedImage bufferedimage1 = new BufferedImage(i, j, 1);
            java.awt.Graphics2D graphics2d1 = bufferedimage1.createGraphics();
            if(debug)
            {
                System.out.println("Size: " + i + " " + j);
            }
            barcode.setSize(i, j);
            barcode.paint(graphics2d1);
            if(s.compareToIgnoreCase("gif") == 0)
            {
                GifEncoder gifencoder = new GifEncoder(bufferedimage1, servletoutputstream);
                gifencoder.encode();
            } else
            {
                JPEGImageEncoder jpegimageencoder = JPEGCodec.createJPEGEncoder(servletoutputstream);
                JPEGEncodeParam jpegencodeparam = jpegimageencoder.getDefaultJPEGEncodeParam(bufferedimage1);
                jpegencodeparam.setQuality(1.0F, true);
                jpegimageencoder.setJPEGEncodeParam(jpegencodeparam);
                jpegimageencoder.encode(bufferedimage1, jpegencodeparam);
            }
        }
        catch(Exception exception)
        {
            exception.printStackTrace();
        }
    }

    public void doPost(HttpServletRequest httpservletrequest, HttpServletResponse httpservletresponse)
        throws ServletException
    {
        try
        {
            doGet(httpservletrequest, httpservletresponse);
        }
        catch(Exception exception)
        {
            exception.printStackTrace();
        }
    }
}

